/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*                    BinkleyTerm BBS Session Initiator                     */
/*                                                                          */
/*                                                                          */
/*   This  software  package is being distributed WITH FULL SOURCE CODE     */
/*   with the  following  conditions:    1)  If  anything awful happens     */
/*   because  you  use    it   (or  don't  use  it),  you  accept  full     */
/*   responsibility;  2) you  don't start making tons of voice calls to     */
/*   the authors to complain or  make  suggestions  about enhancements,     */
/*   useful or otherwise;  3) you  do not reuse this code in commercial     */
/*   products without specific permission to do so  from  the  authors;     */
/*   4) If you find any problems you send  fixes  to  the  authors  for     */
/*   inclusion  in  updates;    5) You find some way  to  express  your     */
/*   appreciation  for  this  method of distribution, either by writing     */
/*   code or  application  notes,  or  just sending along a "Thank You"     */
/*   message.                                                               */
/*                                                                          */
/*   There is  copyrighted  code  in  this product.  We either wrote it     */
/*   ourselves or got  permission  to use it.  Please don't force us to     */
/*   pay a lawyer --  have some respect for our motives and don't abuse     */
/*   this "license".                                                        */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <conio.h>

#define WAZOO_SECTION
#define MATRIX_SECTION

#include "com.h"
#include "xfer.h"

extern int share;				/* Whether to drop FOSSIL*/
extern char *BBSopt;				/* User spec'd BBS call  */
extern struct baud_str btypes[];
extern int port_ptr;
extern FILE *status_log;
extern int baud;

BBSexit()
{
int retval;
char command[80];
long t1, timerset ();

/* Wait a half second */
timer (50);

/* Now if there is no carrier bag it */
if (!CARRIER)
   {
   status_line ("!Lost Caller");
   return;
   }

if (strnicmp(BBSopt,"exit",4) == 0)		/* if BBS flag is "exit" */
	{
   retval = cur_baud / 100;
   status_line (":Exiting to BBS with Errorlevel %d", retval);
	if (!share)				/* Turn off FOSSIL,      */
		MDM_DISABLE();			/* if need be            */
	exit(retval);				/* and exit with error   */
	}
else if (strnicmp(BBSopt, "spawn", 5) == 0)  /* if BBS flag is "spawn" */
   {
   status_line (":Spawning BBS");
   gotoxy(0,22);
   sprintf (command, "SPAWNBBS %d %d %d", cur_baud, port_ptr + 1, time_to_next());
   if (!share)
      MDM_DISABLE();
   
   /* Close the log file */
   if (status_log != NULL)
      fclose (status_log);

   /* Run the BBS */
   system (command);

   /* Re-enable ourselves */
   if (status_log != NULL)
      {
		if ((status_log = fopen (ctl.log_name, "aa")) == NULL)
         {
         cprintf ("\r\nCannot re-open logfile\r\n");
         }
      }

   if (Cominit(port_ptr) != 0x1954)
	   {
      cprintf ("\r\nDarn!  The FOSSIL seems to have gone away!  Exiting\r\n");
      exit (1);
   	}

   MDM_ENABLE(btypes[baud].rate);
   opening_banner ();
   mailer_banner ();

   status_line (":Returned from BBS");
   }
}
