/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*                       BinkleyTerm "HELP" Module                          */
/*                                                                          */
/*                                                                          */
/*   This  software  package is being distributed WITH FULL SOURCE CODE     */
/*   with the  following  conditions:    1)  If  anything awful happens     */
/*   because  you  use    it   (or  don't  use  it),  you  accept  full     */
/*   responsibility;  2) you  don't start making tons of voice calls to     */
/*   the authors to complain or  make  suggestions  about enhancements,     */
/*   useful or otherwise;  3) you  do not reuse this code in commercial     */
/*   products without specific permission to do so  from  the  authors;     */
/*   4) If you find any problems you send  fixes  to  the  authors  for     */
/*   inclusion  in  updates;    5) You find some way  to  express  your     */
/*   appreciation  for  this  method of distribution, either by writing     */
/*   code or  application  notes,  or  just sending along a "Thank You"     */
/*   message.                                                               */
/*                                                                          */
/*   There is  copyrighted  code  in  this product.  We either wrote it     */
/*   ourselves or got  permission  to use it.  Please don't force us to     */
/*   pay a lawyer --  have some respect for our motives and don't abuse     */
/*   this "license".                                                        */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include "com.h"

extern char *BBSreader;

static char *mhelp[] = {
   "\033[H\033[2J",
   "You now have BinkleyTerm in DUMB TERMINAL mode.\r\n",
   "In DUMB TERMINAL mode the following special keys are enabled:\r\n\r\n",
   "     Alt-F10   Display this help screen.\r\n",
   "     Alt-Y     Ya-hooey! Initiate a netmail session with host\r\n",
   "     Alt-U     Shift into UNATTENDED MAILER mode\r\n",
   "     Alt-M     Initiate a mail session to any node in list\r\n",
   "     Alt-X     Exit BinkleyTerm, return to DOS (DTR left high)\r\n",
   "     Alt-H     Hang up the phone by dropping DTR.\r\n",
   "     Alt-L     Start or stop logging of session to a file\r\n",
   "     Alt-B     Set BT's baud rate to next higher value (19200 goes to 300)\r\n",
   "     Alt-D     Instruct BT to dial a system.\r\n",
   "     Alt-P     Use the other com port now (COM1 <-> COM2)\r\n",
   "     PgUp      Send a file to Opus (UPLOAD)\r\n",
   "     PgDn      Receive a file from Opus (DOWNLOAD)\r\n",
   "\r\nPress a key to continue...",
   NULL
};

static char *uhelp[] = {
   "\033[H\033[2J",
   "You now have BinkleyTerm in UNATTENDED MAILER mode.\r\n",
   "In UNATTENDED MAILER mode the following special keys are enabled:\r\n\r\n",
   "     Alt-F10   Display this help screen.\r\n",
   "     F1..F10   Exit to DOS with errorlevel (10*n) (F1=10,etc)\r\n",
   "     ESCape    Push to DOS (spawn COMMAND.COM)\r\n",
   "     Alt-M     Manually POLL a node\r\n",
   "     Alt-Q     Quit the current event\r\n",
   "     Alt-R     Re-start mail events as though none have previously executed\r\n",
   "     Alt-T     Shift into DUMB TERMINAL mode.\r\n",
   "     C         Make the next call (if any) immediately\r\n",
   "     Ctl-C     Exit from BT with ERRORLEVEL 1\r\n",
   "     Alt-X     Exit from BT with ERRORLEVEL 1\r\n",
   NULL
};

main_help()
{
   int i;

   for (i = 0; mhelp[i] != NULL; i++)
      scr_printf (mhelp[i]);

   FOSSIL_CHAR();
   scr_printf ("\r\n");
}

mailer_help()
{
   int i;

   for (i = 0; uhelp[i] != NULL; i++)
      scr_printf (uhelp[i]);

   if (BBSreader != NULL)
      {
      scr_printf("     Alt-E     Execute '");
      scr_printf(BBSreader);
      scr_printf("' as message editor\r\n");
      }
   
   scr_printf ("\r\nPress a key to continue...");
   FOSSIL_CHAR();
   scr_printf ("\r\n");
}
